// UtenteDoc.cpp : implementation of the CUtenteDoc class
//

#include "stdafx.h"
#include "Utente.h"

#include "Conn.h"
#include "UtenteDoc.h"
#include "UtenteView.h"
#include "msg.h"
#include "..\nameserver\nameMsg.H"
#include "LogonDlg.h"
#include "ConnName.h"
#include "ChangeName.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUtenteDoc

IMPLEMENT_DYNCREATE(CUtenteDoc, CDocument)

BEGIN_MESSAGE_MAP(CUtenteDoc, CDocument)
	//{{AFX_MSG_MAP(CUtenteDoc)
	ON_COMMAND(ID_STAT, OnStat)
	ON_COMMAND(ID_CAMBIA_NICK, OnCambiaNick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUtenteDoc construction/destruction

CUtenteDoc::CUtenteDoc()
{
	// TODO: add one-time construction code here
	m_pStream = NULL;
	m_pIn = NULL;
	m_pOut = NULL;
	m_strAddStanza = _T("");
	m_nPort = 0;
	m_pConn = NULL;
	m_NameServer = _T("");
	m_strNameStanza = _T("");
	m_strDescStanza = _T("");
}

CUtenteDoc::~CUtenteDoc()
{
}


// questo ovveride della classe CDocument viene richiamato alla creazione di un nuovo documento
// il documento rappresenta lo stato di dialogo con una stanza
// 
// viene visualizzata una finestra di dialogo per ottenere i dati di connessione (nameserver,nome stanza e nick)
// il nome stanza viene risolto e connesso attraverso la funzione ConnettiName

BOOL CUtenteDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	((CEditView*)m_viewList.GetHead())->SetWindowText(NULL);


	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	CLogonDlg Logon;
	Logon.m_strNick=m_strNick;
	Logon.m_NameServer=_T("localhost");
	Logon.m_strNameStanza=_T("");
	
	while(TRUE)
		{
			if (IDOK != Logon.DoModal())
				return FALSE;

			m_NameServer = Logon.m_NameServer;
			m_strNick = Logon.m_strNick;
			m_strNameStanza = Logon.m_strNameStanza;

			if (ConnettiName()) return TRUE;

			if (AfxMessageBox(IDS_RIPROVA_LOGON,MB_YESNO) == IDNO)
				return FALSE;
		}			
}


// Questa funzione recupera l'indirizzo comunicando con il nameserver e poi tenta la connessione, queste operazioni sono sincrone
// del resto l'utente a questo punto non ha altro da fare che provare a connettersi con una stanza
BOOL CUtenteDoc::ConnettiName()
{
		CConnName pSocket(this);
		CNameMsg msg(m_strNameStanza);

		if(pSocket.RetrieveName(m_NameServer,msg) && Connetti(m_strNick, m_strAddStanza, m_nPort))
		{
			CString temp;
			temp.Format("%s connesso a %s (%s:%d)",m_strNick,m_strNameStanza,m_strAddStanza,m_nPort+PORTA_BASE);
			SetTitle(temp);
			return TRUE;
		}
		else 
		{
			CString temp;
			temp.Format("%s, connessione fallita a %s",m_strNick,m_strNameStanza);
			SetTitle(temp);
			return FALSE;
		}
}


/////////////////////////////////////////////////////////////////////////////
// CUtenteDoc serialization

void CUtenteDoc::Serialize(CArchive& ar)
{
	// CEditView contains an edit control which handles all serialization
	((CEditView*)m_viewList.GetHead())->SerializeRaw(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CUtenteDoc diagnostics

#ifdef _DEBUG
void CUtenteDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CUtenteDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CUtenteDoc commands

// quando chiamo questa funzione m_pIn deve essere non nullo
void CUtenteDoc::Receive()
{
	CMsg msg;
	CString first=_T("");;

	try
	{
		msg.Serialize(*m_pIn);

		// prendo la prima stringa del messaggio e la copio, dopo infatti devo controllare se essa  una richiesta di migrazione
		first = msg.m_msgList.GetAt(msg.m_msgList.GetHeadPosition());
		
		while(!msg.m_msgList.IsEmpty())
		{
			CString temp = msg.m_msgList.RemoveHead();
			Visualizza(temp);
		}
	}
	catch(...)
	{
		// diviene l'ultimo messaggio
		msg.m_bClose = TRUE;
		m_pOut->Abort();

		CString strTemp;		
		if (strTemp.LoadString(IDS_CONNESSIONE_CHIUSA)) Visualizza(strTemp);	
		if (strTemp.LoadString(IDS_STANZA_CHIUSA)) Visualizza(strTemp);
	}

	// nel caso in cui sia l'ultimo messaggio 

	if (msg.m_bClose)
	{
			
		ResetConn();
		
		// controllo della presenza del comando di migrazione, viene fatto all'interno di questo if, perch deve avvenire
		// in corrispondenza della segnalazione di chiusura della comunicazione da parte del server.
		CString strTemp;
		int i;
		if (strTemp.LoadString(IDS_MIGRAZIONE))
			i = first.Find(strTemp);
		// avviene la migrazione
		if(i>=0)
		{
			LPCTSTR s = (LPCTSTR) first;
			m_strNameStanza = (LPCTSTR) s+i+1+strTemp.GetLength();// c' anche uno spazio

			if (!ConnettiName()) 
			{
				Visualizza("Migrazione fallita. Spostarsi in una nuova stanza");
			}
		}
	}

}



void CUtenteDoc::Send(CString &strTesto)
{
	if (m_pOut != NULL)
	{
		CMsg msg;

		msg.m_strText = m_strNick + _T("-> ") + strTesto;

		try
		{
			msg.Serialize(*m_pOut);
			m_pOut->Flush();
		}
		catch(...)
		{
			
			m_pOut->Abort();
			delete m_pOut;
			m_pOut = NULL;
		
			CString strTemp;
			if (strTemp.LoadString(IDS_CONNESSIONE_CHIUSA))
				Visualizza(strTemp);
			
		}
	}
}

void CUtenteDoc::Visualizza(LPCTSTR testo)
{
	
	((CUtenteView*)m_viewList.GetHead())->AppendiTesto(testo);
		
}

void CUtenteDoc::Read()
{
	do
	{
		Receive();
		if (m_pConn == NULL)
			return;
	}
	while(!m_pIn->IsBufferEmpty());
}

BOOL CUtenteDoc::Connetti(LPCTSTR nick, LPCTSTR adr, int port)
{
	m_pConn = new CConn(this);


	if (!m_pConn->Create())
	{
		delete m_pConn;
		m_pConn = NULL;
		AfxMessageBox(IDS_FALLITA_CONNESSIONE);
		return FALSE;
	}

	while (!m_pConn->Connect(adr, port + PORTA_BASE))
	{
		if (AfxMessageBox(IDS_RIPROVA_CONNESSIONE,MB_YESNO) == IDNO)
		{
			delete m_pConn;
			m_pConn = NULL;
			return FALSE;
		}
	}

	BOOL b = TRUE;
	m_pConn->SetSockOpt(TCP_NODELAY,&b,sizeof(BOOL));
	m_pConn->SetSockOpt(SO_KEEPALIVE,&b,sizeof(BOOL));

	m_pStream = new CSocketFile(m_pConn);
	m_pIn = new CArchive(m_pStream,CArchive::load);
	m_pOut = new CArchive(m_pStream,CArchive::store);

	CString t;
	if (t.LoadString(IDS_CONNESSO))
		Send(t);

	return TRUE;	
}

void CUtenteDoc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class

	if ((m_pConn!= NULL) && (m_pStream != NULL) && (m_pOut != NULL))
	{
		CMsg msg;
		CString strTemp;

		if (strTemp.LoadString(IDS_DISCONNESSO))
		{
			msg.m_bClose = TRUE;
			msg.m_strText = m_strNick + strTemp;
			msg.Serialize(*m_pOut);
			m_pOut->Flush();
		}
	}

	if (m_pConn != NULL)
	{
		BYTE Buffer[50];
		m_pConn->ShutDown();

		while(m_pConn->Receive(Buffer,50) > 0);
	}

	ResetConn();

//	((CUtenteView*)m_viewList.GetHead())->GetEditCtrl().SetWindowText(_T(""));

	CDocument::DeleteContents();
}

void CUtenteDoc::OnStat() 
{
	// TODO: Add your command handler code here
	VisualizzaStat();
}

void CUtenteDoc::VisualizzaStat()
{
	Visualizza("Statistiche sull'utente");
	CString temp;
	temp.Format("Nick: %s", m_strNick);
	Visualizza(temp);
	temp.Format("NameServer: %s:%d", m_NameServer,PORTA_UTENTI);
	Visualizza(temp);
	temp.Format("Stanza: %s", m_strNameStanza);
	Visualizza(temp);
	temp.Format("Indirizzo stanza: %s:%d", m_strAddStanza,m_nPort);
	Visualizza(temp);
	temp.Format("Descrizione Stanza: %s", m_strDescStanza);
	Visualizza(temp);
	int i = ((CUtenteView*)m_viewList.GetHead())->GetBufferLength( );
	temp.Format("Byte discussione: %d", i );
	Visualizza(temp);

}


void CUtenteDoc::OnCambiaNick() 
{
	// TODO: Add your command handler code here
	CChangeName dialog;
	
	if (IDOK != dialog.DoModal())
			return;

	Send(m_strNick + " ho cambiato il mio nick in " + dialog.m_strNick);
	
	m_strNick = dialog.m_strNick;
}

void CUtenteDoc::ResetConn()
{
	delete m_pIn;
	m_pIn = NULL;
	delete m_pOut;
	m_pOut = NULL;
	delete m_pStream;
	m_pStream = NULL;
	delete m_pConn;
	m_pConn = NULL;
}

