

#include "stdafx.h"
#include "cltStanze.h"
#include "nameserverDoc.h"
#include "nameMsg.h"

/////////////////////////////////////////////////////////////////////////////
// CClientStanze Construction

CClientStanze::CClientStanze(CNameserverDoc* pDoc)
{
	m_pDoc = pDoc;
	m_pStream = NULL;
	m_pIn = NULL;
	m_pOut = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CClientStanze Operations

void CClientStanze::Init()
{
	m_pStream = new CSocketFile(this);
	m_pIn = new CArchive(m_pStream,CArchive::load);
	m_pOut = new CArchive(m_pStream,CArchive::store);
}

void CClientStanze::SendMsg(CNameMsg* pMsg)
{
	if (m_pOut != NULL)
	{
		pMsg->Serialize(*m_pOut);
		m_pOut->Flush();
	}
}

void CClientStanze::ReceiveMsg(CNameMsg* pMsg)
{
	pMsg->Serialize(*m_pIn);
}

/////////////////////////////////////////////////////////////////////////////
// CClientStanze Overridable callbacks

void CClientStanze::OnReceive(int nErrorCode)
{
	CSocket::OnReceive(nErrorCode);

	m_pDoc->RiceviStanza(this);
}

/////////////////////////////////////////////////////////////////////////////
// CSocket Implementation

CClientStanze::~CClientStanze()
{
	if (m_pOut != NULL)
		delete m_pOut;

	if (m_pIn != NULL)
		delete m_pIn;

	if (m_pStream != NULL)
		delete m_pStream;
}

#ifdef _DEBUG
void CClientStanze::AssertValid() const
{
	CSocket::AssertValid();
}

void CClientStanze::Dump(CDumpContext& dc) const
{
	CSocket::Dump(dc);
}
#endif //_DEBUG

IMPLEMENT_DYNAMIC(CClientStanze, CSocket)
