

#include "stdafx.h"
#include "cltUtenti.h"
#include "nameserverDoc.h"
#include "nameMsg.h"

/////////////////////////////////////////////////////////////////////////////
// CClientUtenti Construction

CClientUtenti::CClientUtenti(CNameserverDoc* pDoc)
{
	m_pDoc = pDoc;
	m_pStream = NULL;
	m_pIn = NULL;
	m_pOut = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CClientUtenti Operations

void CClientUtenti::Init()
{
	m_pStream = new CSocketFile(this);
	m_pIn = new CArchive(m_pStream,CArchive::load);
	m_pOut = new CArchive(m_pStream,CArchive::store);
}


void CClientUtenti::SendMsg(CNameMsg* pMsg)
{
	if (m_pOut != NULL)
	{
		pMsg->Serialize(*m_pOut);
		m_pOut->Flush();
	}
}

void CClientUtenti::ReceiveMsg(CNameMsg* pMsg)
{
	pMsg->Serialize(*m_pIn);
}

/////////////////////////////////////////////////////////////////////////////
// CClientUtenti Overridable callbacks

void CClientUtenti::OnReceive(int nErrorCode)
{
	CSocket::OnReceive(nErrorCode);

	m_pDoc->RiceviUtente(this);
}

/////////////////////////////////////////////////////////////////////////////
// CSocket Implementation

CClientUtenti::~CClientUtenti()
{
	if (m_pOut != NULL)
		delete m_pOut;

	if (m_pIn != NULL)
		delete m_pIn;

	if (m_pStream != NULL)
		delete m_pStream;
}

#ifdef _DEBUG
void CClientUtenti::AssertValid() const
{
	CSocket::AssertValid();
}

void CClientUtenti::Dump(CDumpContext& dc) const
{
	CSocket::Dump(dc);
}
#endif //_DEBUG

IMPLEMENT_DYNAMIC(CClientUtenti, CSocket)
