// nameserverDoc.h : interface of the CNameserverDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NAMESERVERDOC_H__540E84BE_374C_48BD_AF5B_EC09BA965954__INCLUDED_)
#define AFX_NAMESERVERDOC_H__540E84BE_374C_48BD_AF5B_EC09BA965954__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define PORTA_UTENTI 41251
#define PORTA_STANZE 41250
#define PORTA_BASE 41200

#ifdef _DEBUG
#define CHECK_TIME 10000
#else
#define CHECK_TIME 60000
#endif

#define MIN_TIME2LIVE 5
#define NUM_TRIES 3
#define IDM_LOGOUT -2 // logout dal name server
#define IDM_CONFIRM -1 // messaggio di conferma dal name server
#define IDM_ERROR -3 // errore name server

class CNameMsg;
class CClientUtenti;
class CClientStanze;
class CListeningUtenti;
class CListeningStanze;
class CCheckConn;

class CNameserverDoc : public CDocument
{
protected: // create from serialization only
	CNameserverDoc();
	DECLARE_DYNCREATE(CNameserverDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNameserverDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	void ImpostaT2L(CNameMsg* pMsg);
	BOOL AggiornaT2L(CNameMsg &msg);
	CCheckConn* m_pCheckConn;
	int CheckStanza(CNameMsg* pMsg);
	void CheckT2L();
	void RisolviStanza(CNameMsg *pMsg, CClientStanze* pSocket);
	void VisualizzaMsg(CNameMsg &msg);
	void VisualizzaStanze();
	BOOL DeleteStanza(CNameMsg* pMsg);
	CNameMsg *TrovaStanza(CNameMsg * const pMsg, BOOL checkAdd = FALSE) const;
	void Visualizza(LPCTSTR testo);
	void RiceviUtente(CClientUtenti* pSocket);
	void RiceviStanza(CClientStanze* pSocket);
	CListeningUtenti* m_pListenUtenti;
	CListeningStanze* m_pListenStanze;
	void AccettaUtenti();
	void AccettaStanza();
	CPtrList m_StanzeList;
	virtual ~CNameserverDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CNameserverDoc)
	afx_msg void OnViewStanze();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NAMESERVERDOC_H__540E84BE_374C_48BD_AF5B_EC09BA965954__INCLUDED_)
