// ConnName.cpp : implementation file
//

#include "stdafx.h"
#include "Stanza.h"

#include "Stanzadoc.h"
#include "ConnName.h"
#include "..\nameserver\nameMsg.H"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CConnName, CSocket)

/////////////////////////////////////////////////////////////////////////////
// CConnName

CConnName::CConnName(CStanzaDoc *pDoc)
{
	m_pDoc = pDoc;
	m_pStream = NULL;
	m_pIn = NULL;
	m_pOut = NULL;
}

void CConnName::Init()
{
	m_pStream = new CSocketFile(this);
	m_pIn = new CArchive(m_pStream,CArchive::load);
	m_pOut = new CArchive(m_pStream,CArchive::store);
}


CConnName::~CConnName()
{
	if (m_pOut != NULL)
		delete m_pOut;

	if (m_pIn != NULL)
		delete m_pIn;

	if (m_pStream != NULL)
		delete m_pStream;
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CConnName, CSocket)
	//{{AFX_MSG_MAP(CConnName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CConnName member functions

void CConnName::OnReceive(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CSocket::OnReceive(nErrorCode);
    
	// deve essere l'ultima operazione perch autodistrugge l'oggetto
	m_pDoc->ConfermaName(this);
}

void CConnName::SendMsg(CNameMsg* pMsg)
{
	if (m_pOut != NULL)
	{
		pMsg->Serialize(*m_pOut);
		m_pOut->Flush();
	}
}

void CConnName::ReceiveMsg(CNameMsg* pMsg)
{
	pMsg->Serialize(*m_pIn);
}


BOOL CConnName::RegistraName(LPCTSTR nameServer, CNameMsg &nameMsg)
{
	
	if (!Create())
	{
		AfxMessageBox(IDS_ERRORE_SOCKET);
		return FALSE;
	}

	while (!Connect(nameServer, PORTA_STANZE))
		if (AfxMessageBox(IDS_RIPROVA_CONNESSIONE,MB_YESNO) == IDNO)
			return FALSE;

	Init();

	SendMsg(&nameMsg);

	return TRUE;
}

