// StanzaDoc.cpp : implementation of the CStanzaDoc class
//

#include "stdafx.h"
#include "Stanza.h"

#include "..\nameserver\nameMsg.H"
#include "Msg.h"
#include "StanzaView.h"
#include "Conn.h"
#include "ConnName.h"
#include "UtenteConn.h"
#include "LogonDlg.h"
#include "StanzaDoc.h"
#include "CheckConn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStanzaDoc

IMPLEMENT_DYNCREATE(CStanzaDoc, CDocument)

BEGIN_MESSAGE_MAP(CStanzaDoc, CDocument)
	//{{AFX_MSG_MAP(CStanzaDoc)
	ON_COMMAND(ID_STAT, OnStat)
	ON_COMMAND(ID_REGISTRA, OnRegistra)
	ON_COMMAND(ID_VIEW_UTENTI, OnViewUtenti)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStanzaDoc construction/destruction

CStanzaDoc::CStanzaDoc()
{
	// TODO: add one-time construction code here
	m_pConn = NULL;
	m_pCheckConn = NULL;
	m_strName = _T("");
	m_strMigra = _T("");
}

CStanzaDoc::~CStanzaDoc()
{
	delete m_pConn;
	delete m_pCheckConn;
}


// All'interno di questa funzione di inizializzazione del documento parte un ciclo infinito da esso si esce in uno dei seguenti modi:
// 1) annullando la finestra di dialogo iniziale (l'applicazione esce) 
// 2) portando a buon fine la creazione della socket CConn (listening), della socket CCheckConn (per le verifiche del nameserver)
// Non  necessario registrare il nome di stanza presso il name server durante l'inizializzazione, la cosa pu essere infatti rifatta successivamente
BOOL CStanzaDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	((CEditView*)m_viewList.GetHead())->SetWindowText(NULL);

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)


	while(TRUE)
	{
		delete m_pConn;
		m_pConn = NULL;
		delete m_pCheckConn;
		m_pCheckConn = NULL;

		m_Dialog.m_strNameServer=_T("localhost");
		if (m_Dialog.DoModal() != IDOK)
			return FALSE;

		m_pConn = new CConn(this);
		if (m_pConn->Create(m_Dialog.m_nPort+PORTA_BASE))
			if (!m_pConn->Listen())
				continue;


		// inizializza tutte le variabili membro di StanzaDoc
		m_strName = m_Dialog.m_strNameStanza;
		m_nPort = m_Dialog.m_nPort;
		m_strDesc = m_Dialog.m_strDescStanza;
		m_strNameServer = m_Dialog.m_strNameServer;
		m_strAdd = m_Dialog.m_strAddStanza;

		m_pCheckConn = new CCheckConn(this);
		if (!m_pCheckConn->Create(m_Dialog.m_nPort+PORTA_BASE,SOCK_DGRAM) || !m_pCheckConn->Init())
			continue;
			
		if (RegistraName()) return TRUE;
		if (AfxMessageBox(IDS_CAMBIADATI,MB_YESNO) == IDNO)
		{
			CString temp;
			if (temp.LoadString(IDS_NO_REGISTER)) 
				Visualizza(temp);
			return TRUE;
		}

	}

}


BOOL CStanzaDoc::RegistraName()
{
	CConnName* pConnName = new CConnName(this);
	CNameMsg nameMsg(m_strName,m_strAdd,m_nPort,m_strDesc,TIME_TO_LIVE);
	nameMsg.m_nTries=NUM_TRIES;
	if (pConnName->RegistraName(m_strNameServer,nameMsg))
	{
		if(m_strAdd==_T(""))
		{
			UINT dummy;
			pConnName->GetSockName(m_strAdd, dummy);	
		}
		
		CString temp;
		temp.Format("%s (%s:%d)",m_strName, m_strAdd, m_nPort+PORTA_BASE);
		SetTitle(temp);

		return TRUE;
	}

	return FALSE;

}


// richiamata dal menu
void CStanzaDoc::OnRegistra() 
{
	// TODO: Add your command handler code here
//	m_Dialog.Create(IDD_STANZA);
	
	if (m_Dialog.DoModal() != IDOK)
		return;

	m_strName = m_Dialog.m_strNameStanza;
	m_strDesc = m_Dialog.m_strDescStanza;
	m_strNameServer = m_Dialog.m_strNameServer;

	RegistraName();

}

void CStanzaDoc::ConfermaName(CConnName *pSocket)
{
	CNameMsg* pMsg = new CNameMsg;
	CString strTemp;

	try
	{
		// l'operazione  idempotente
		do {
			pSocket->ReceiveMsg(pMsg);
			
			strTemp.LoadString(IDS_LOGON_OK);

			if (pMsg->m_nPort==IDM_CONFIRM)
			{
				if(strTemp.LoadString(IDS_LOGON_OK))
					Visualizza(strTemp);			
			}
			else if (pMsg->m_nPort==IDM_ERROR)
			{
				Visualizza(pMsg->m_strName);
				m_strName = (LPCTSTR) NULL;
			}
		} while (!pSocket->m_pIn->IsBufferEmpty());
	}
	catch(...)
	{
		CString strTemp;
		if (strTemp.LoadString(IDS_ERRORE_SOCKET))
			Visualizza(strTemp);
		
	}

	delete pSocket;	
	delete pMsg;
}

void CStanzaDoc::CancellaName()
{
	CConnName ConnName(this);
	CNameMsg nameMsg(m_strName,NULL,IDM_LOGOUT);
	ConnName.RegistraName(m_strNameServer,nameMsg);	
}

/////////////////////////////////////////////////////////////////////////////
// CStanzaDoc serialization

void CStanzaDoc::Serialize(CArchive& ar)
{
	// CEditView contains an edit control which handles all serialization
	((CEditView*)m_viewList.GetHead())->SerializeRaw(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CStanzaDoc diagnostics

#ifdef _DEBUG
void CStanzaDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CStanzaDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CStanzaDoc commands

void CStanzaDoc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class
	delete m_pConn;
	m_pConn = NULL;

	CString temp;	
	if (m_strMigra==_T(""))
	{
		if (temp.LoadString(IDS_STANZA_CHIUSA)) 
			m_msgList.AddTail(temp);
	}
	else
		if (temp.LoadString(IDS_MIGRAZIONE)) 
			m_msgList.AddTail(temp + " " + m_strMigra);


	while(!m_UtentiList.IsEmpty())
	{
		CUtenteConn* pUtenteConn = (CUtenteConn*)m_UtentiList.RemoveHead();
		CMsg* pMsg = GeneraUpdateUtente(pUtenteConn);
		pMsg->m_bClose = TRUE;

		SendMsg(pUtenteConn, pMsg);

		if (!pUtenteConn->IsAborted())
		{
			pUtenteConn->ShutDown();

			BYTE Buffer[50];

			while (pUtenteConn->Receive(Buffer,50) > 0);

		}

		delete pUtenteConn;
	}

	m_msgList.RemoveAll();

	if (!m_viewList.IsEmpty())
		((CEditView*)m_viewList.GetHead())->SetWindowText(_T(""));

	if (m_strName.GetLength()>0)
		CancellaName();

	CDocument::DeleteContents();
}



void CStanzaDoc::Accetta()
{
	CUtenteConn* pUtenteConn = new CUtenteConn(this);

	if (m_pConn->Accept(*pUtenteConn))
	{
		pUtenteConn->Init();
		BOOL b = TRUE;
		pUtenteConn->SetSockOpt(TCP_NODELAY,&b,sizeof(BOOL));
		pUtenteConn->SetSockOpt(SO_KEEPALIVE,&b,sizeof(BOOL));
		m_UtentiList.AddTail(pUtenteConn);
	}
	else delete pUtenteConn;
}


// cancella la connessione solo se la ha effettivamente trovata tra le connessioni attive
void CStanzaDoc::RimuoviUtente(CUtenteConn* pUtenteConn)
{
	pUtenteConn->Close();

	POSITION pos,temp;
	for(pos = m_UtentiList.GetHeadPosition(); pos != NULL;)
	{
		temp = pos;
		CUtenteConn* pUC = (CUtenteConn*)m_UtentiList.GetNext(pos);
		if (pUC == pUtenteConn)
		{
			m_UtentiList.RemoveAt(temp);
			delete pUtenteConn;
			break;
		}
	}

}



void CStanzaDoc::Read(CUtenteConn *pUtenteConn)
{
	do
	{
		CMsg* pMsg = ReadMsg(pUtenteConn);

		if (pMsg->m_bClose)
		{
			RimuoviUtente(pUtenteConn);
			break;
		}
	}
	while (!pUtenteConn->m_pIn->IsBufferEmpty());

	SendTuttiUtenti();
}

CMsg* CStanzaDoc::ReadMsg(CUtenteConn *pUtenteConn)
{
	static CMsg msg;

	try
	{
		pUtenteConn->ReceiveMsg(&msg);

		Visualizza(msg.m_strText);

		m_msgList.AddTail(msg.m_strText);
	}
	catch(...)
	{
		ErroreUtente(pUtenteConn);
		msg.m_bClose=FALSE; // altrimenti potrebbe richiamare nuovamente la funzione rimuovi utente
	}

	return &msg;
}


void CStanzaDoc::SendTuttiUtenti()
{
	do
	{
		
		m_bNewMsg = FALSE;
		for(POSITION pos = m_UtentiList.GetHeadPosition(); pos != NULL;)
		{
			CUtenteConn* pUtenteConn = (CUtenteConn*)m_UtentiList.GetNext(pos);
			CMsg* pMsg = GeneraUpdateUtente(pUtenteConn);

			if (pMsg != NULL) SendMsg(pUtenteConn, pMsg);
		}

	} while(m_bNewMsg);
}

void CStanzaDoc::SendMsg(CUtenteConn *pUtenteConn, CMsg *pMsg)
{
	try
	{
		pUtenteConn->SendMsg(pMsg);
	}
	catch(...)
	{		
		ErroreUtente(pUtenteConn);
	}

}


void CStanzaDoc::ErroreUtente(CUtenteConn* pUtenteConn)
{
	pUtenteConn->Abort();
	CString nick = pUtenteConn->m_strNick;
	
	
	m_msgList.AddTail(nick + " non raggiungibile, potrebbe non aver ricevuto gli ultimi messaggi");
	m_msgList.AddTail(nick + "  uscito dalla stanza");
	m_bNewMsg = TRUE;
	
	RimuoviUtente(pUtenteConn);

	CString strTemp;
	if (strTemp.LoadString(IDS_ERRORE_SOCKET)) Visualizza(strTemp + ": " + nick + " eliminato");
}

void CStanzaDoc::OnCloseUtenteConn(CUtenteConn* pSocket)
{
	ErroreUtente(pSocket);
	SendTuttiUtenti();
}


CMsg* CStanzaDoc::GeneraUpdateUtente(CUtenteConn *pUtenteConn)
{
	static CMsg msg;

	msg.Init();

	if (pUtenteConn->m_nNMsg >= m_msgList.GetCount())
		return NULL;

	for (POSITION pos1 = m_msgList.FindIndex(pUtenteConn->m_nNMsg); pos1 != NULL;)
	{
		CString temp = m_msgList.GetNext(pos1);
		msg.m_msgList.AddTail(temp);
	}
	pUtenteConn->m_nNMsg = m_msgList.GetCount();
	return &msg;
}


void CStanzaDoc::VisualizzaStat()
{
	CString temp;
	Visualizza("Statistiche stanza");
	temp.Format("Nome: %s", m_strName);
	Visualizza(temp);
	temp.Format("Indirizzo: %s:%d", m_strAdd,m_nPort);
	Visualizza(temp);
	temp.Format("Desc: %s", m_strDesc);
	Visualizza(temp);
	temp.Format("NameServer: %s:%d", m_strNameServer,PORTA_STANZE);
	Visualizza(temp);
	temp.Format("Numero Messaggi: %d", m_msgList.GetCount());
	Visualizza(temp);
		
}

inline void CStanzaDoc::Visualizza(LPCTSTR testo)
{
	((CStanzaView*)m_viewList.GetHead())->Visualizza(testo);
}

void CStanzaDoc::OnStat() 
{
	// TODO: Add your command handler code here
	VisualizzaStat();
}


void CStanzaDoc::VisualizzaTuttiUtenti()
{
	Visualizza("Utenti presenti nella stanza");
	for(POSITION pos = m_UtentiList.GetHeadPosition(); pos != NULL;)
	{
		CUtenteConn* pUtenteConn = (CUtenteConn*)m_UtentiList.GetNext(pos);
		Visualizza(pUtenteConn->m_strNick);
	}
}

void CStanzaDoc::OnViewUtenti() 
{
	// TODO: Add your command handler code here
	VisualizzaTuttiUtenti();
}



